--Created by Josh Garrett
--Additional help from liacrow(ravenshining) :) 
--Contact: @anonfriction on twitter or AnonFriction#6618 on discord 

Triggers = {}
CollectionsUsed = { 1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,31 }

Potential_Hills = {}
timer = -1
hills = 0
hill_set = 0
active_hill = nil
key_life = 210

function Triggers.init()
	find_hills() --Iterates through polygons to check for potential hills
end

function Triggers.idle()	
	run_game()
end

function Triggers.player_killed(player, aggressor_player, action, projectile)	
	Items.new(player.x, player.y, .25, player.polygon, "key")
end

function Triggers.item_created(item)
    if item.type == "key" then
		item._life = key_life
    end
end

function run_game()
	round_timer() --Custom timer since Game.ticks cannot be manipulated
	if timer % 900 == 0 and hills > 1 then
		change_hill() --Rotates the active hill if a map has more than one
	elseif hills == 1 and hill_set ~= 1 then
		single_hill()  --Activates the hill if there is only one
	elseif hills == 0 then
	Players.print("This map has no hills. Please select another map")
	end	
	for p in Players() do
	setUpCompass(p) --Enables the Compass if the player is holding keys
	score(p) --Deletes keys from inventory and converts to points when touching the Hill
	end
	item_life() --Manages keys and deletes them when life is zero
	overlays() --Manages overlays which show the player the number of held keys
end

function round_timer()
	timer = timer + 1
end

function item_life()
	for i in Items() do
		if i.type == "key" then
			i._life = i._life - 1
				if i._life == 0 then
					i:delete()
				end
		end
	end
end

function setUpCompass()
	for p in Players() do
		p.compass.lua = true
		if p.items["key"] > 0 then
		p.compass.beacon = true
		p.compass.x = active_hill.x
		p.compass.y = active_hill.y
		elseif p.items["key"] == 0 then
		p.compass.beacon = false	
		end
	end
end

function find_hills()
	for p in Polygons() do 
		if p.type == "hill" then
		table.insert(Potential_Hills, p)
		hills = hills + 1
		end
	end
end

function change_hill()
		active_hill = Potential_Hills[Game.random(hills) + 1]
		for p in Players() do
		p:play_sound("alarm", 1)
		Players.print("Hill Moved")
		end
end
	
function single_hill()	
	for p in Polygons() do 
		if p.type == "hill" then 
		active_hill = p
		hill_set = 1
		end
	end	
end

function score()
	for p in Players() do
		if p.polygon == active_hill and p.items["key"] >= 1 then
			p.points = p.points + p.items["key"]
			p.items["key"] = 0
		end
	end
end

function overlays() 
	for p in Players() do
		p.overlays[0].color = "white"
		p.overlays[0].text = "Keys held: "..p.items["key"]
	end
end