--Created by Josh Garrett
--Additional help from liacrow(ravenshining) :) 
--Contact: @anonfriction on twitter or AnonFriction#6618 on discord 

Triggers = {}
CollectionsUsed = { 1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,31 }

timer = -1 
living_players = 8 -- script below will update this to the proper number if it's not a full match
spectateable = {}

function Triggers.init()
	Game.nonlocal_overlays = true  --allows players to see bullets/lives of player they are spectating
	living_players = # Players
	player_setup() --setup player stats on match start 
	item_delete() --clears map of specified items on match start
end

function Triggers.idle()	
	run_game() --contains multiple functions that need to run every tick (see below for more comments)
end

function Triggers.player_killed(player, aggressor_player, action, projectile)	 
	--scoring
	if aggressor_player then 
		if aggressor_player ~= player then 
			aggressor_player.points = aggressor_player.points + 1 
		end
		--adds a bullet on kill if not at max
		if aggressor_player._bullets < 3 then
		aggressor_player._bullets = aggressor_player._bullets + 1
		end
		--subtracts life from victim
	--grants a pistol + bullet to players if they were out of them on kill
		if aggressor_player._fists == true then
			aggressor_player.items["pistol"] = 1
			aggressor_player.weapons["pistol"]:select() 
			aggressor_player._fists = false 
		end
	end
	
	if player._lives > 0 then 
		player._lives = player._lives - 1
	end
end

function Triggers.item_created(item)
	item_delete() --continues to delete specified items when they attempt to respawn
end

function Triggers.player_revived(player) --setup player stats on respawn
	player._bullets = 1
	player.items["pistol"] = 1
	player.life = 20
end

function item_delete() -- specifies the items to be left on the map (shorter than lising what to delete)
	for i in Items() do 
		if i.type ~= "invisibility" or i.type ~= "infravision" 
		or i.type ~= "oxygen" or i.type ~= "extravision" then
			i:delete()
		end
	end
end


function run_game()
	round_timer() --Creates a timer that can be modified unlike Game.ticks (not used for much in this mode, but I generally create one to be safe)
	for p in Players() do --keeps player from shooting multiple times on a single trigger press or wasting bullets
		if p._triggerTimer == 0 then 
		player_update()
		end
	end
	overlays() --updates bullets/lives overlay
	disable_respawn() --keeps player from spawning when at 0 lives
	disable_trigger() --keeps player from shooting when at 0 bullets by deleting the pistol from inventory
	radar() --enables radar when only two players are left (similar to UAV activation in CoD at 2 players)
	end_game() --ends game if only one player remains (game will end by default if timer/score limit is set)
end

function round_timer()
	timer = timer + 1 
end

function radar()
	for p in Players() do
		if living_players == 2 then 
			p.compass:all_on()
		end
	end
end

function player_setup() -- Setup initial lives/bullets/heath
	for p in Players() do
		p._bullets = 1
		p._lives = 3
		p.items["pistol"] = 1
		p.life = 20
		p._triggerReleased = 1
		p._triggerTimer = 2
		p._firing = 0
		p._obituary = 0
		--built in vars
		p.compass:all_off()
		table.insert(spectateable, p.index)
	end
end

function overlays() --creates overlays for basic player HUD 
	for p in Players() do
		p.overlays[0].color = "white"
		p.overlays[0].text = "Bullets: "..p._bullets
		p.overlays[1].color = "white"
		p.overlays[2].text = "Lives: "..p._lives
	end
end

function player_update() --keeps players bullets updated
	
	for p in Players() do
		if (p.action_flags.left_trigger or p.action_flags.right_trigger) and p._trigger == 0 then
			--p:print("firing")
			p._triggerTimer = 2
			if p.dead ~= true then
				if p.weapons.current.type == "pistol" and p._triggerReleased >= 2 then
			--	p:print("pistol boi")
				p._triggerReleased = 0
				p._bullets = p._bullets - 1	
				end
			end
		end
		if p._bullets == 0 then
			p.items["pistol"] = 0
			--p.weapons:select("fists") --This is not needed because when taking away the players only weapon they will swap to fists
			p._fists = true
		end
		if p._lives == 0 and p._obituary == 0 then
			Players.print(p.name.." is out of lives")
			living_players = living_players - 1
			for k, v in ipairs(spectateable) do
				if p.index == v then
					v = nil
				end
			end
			p:view_player(spectateable[1])
			p._obituary = 1
		end	
	end
end

function disable_trigger() --disables fully automatic pistol, as well as saving player from wasting bullets.
							--action_flags.left_trigger is only true for 1 tick so if the player holds trigger it alternates causing several bullets to be "used" 
	
	for p in Players() do
		if p._triggerTimer ~= 0 then 
			p._triggerTimer = p._triggerTimer - 1
		end 
		if p.action_flags.left_trigger or p.action_flags.right_trigger then 
			p._triggerReleased = p._triggerReleased - 1
		elseif p.action_flags.left_trigger == false then
			p._triggerReleased = p._triggerReleased + 1
		end
		
		if p._triggerReleased < 2 then
			p._trigger = 1
		elseif p._triggerReleased >= 2 then
			p._trigger = 0
		end	
	end
end
		

function disable_respawn()
	for p in Players() do
		if p._lives == 0 then 
			p.action_flags.action_trigger = false --sets the action_trigger to false effectively stopping respawn by blocking interact key interaction
		end
	end
end

function end_game()
	if living_players == 1 then
	Game.over = true
	end
end




